require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PCRE_REGEXP_H)) {
    eval 'sub _PCRE_REGEXP_H () {1;}' unless defined(&_PCRE_REGEXP_H);
    require 'string';
    require 'pcre.ph';
    require 'pcre_stringpiece.ph';
    eval 'sub PCRE_SET_OR_CLEAR {
        my($b, $o) = @_;
	    eval q( &if ($b)  &all_options_ |= ($o);  &else  &all_options_ &= ~($o);  &return * &this);
    }' unless defined(&PCRE_SET_OR_CLEAR);
    eval 'sub PCRE_IS_SET {
        my($o) = @_;
	    eval q(( &all_options_ & $o) == $o);
    }' unless defined(&PCRE_IS_SET);
    eval 'sub UTF8 {
        eval q({  &RE_Options(). &set_utf8( &true); });
    }' unless defined(&UTF8);
    eval 'sub CASELESS {
        eval q({  &RE_Options(). &set_caseless( &true); });
    }' unless defined(&CASELESS);
    eval 'sub MULTILINE {
        eval q({  &RE_Options(). &set_multiline( &true); });
    }' unless defined(&MULTILINE);
    eval 'sub DOTALL {
        eval q({  &RE_Options(). &set_dotall( &true); });
    }' unless defined(&DOTALL);
    eval 'sub EXTENDED {
        eval q({  &RE_Options(). &set_extended( &true); });
    }' unless defined(&EXTENDED);
    eval("sub UNANCHORED () { 0; }") unless defined(&UNANCHORED);
    eval("sub ANCHOR_START () { 1; }") unless defined(&ANCHOR_START);
    eval("sub ANCHOR_BOTH () { 2; }") unless defined(&ANCHOR_BOTH);
    eval 'sub PCRE_MAKE_PARSER {
        my($type,$name) = @_;
	    eval q( &Arg($type*  &p) :  &arg_( &p),  &parser_($name) { }  &Arg($type*  &p,  &Parser  &parser) :  &arg_( &p),  &parser_( &parser) { });
    }' unless defined(&PCRE_MAKE_PARSER);
    if(1) {
    }
    if(1) {
    }
    undef(&PCRE_MAKE_PARSER) if defined(&PCRE_MAKE_PARSER);
    eval 'sub PCRE_DECLARE_INTEGER_PARSER {
        my($name) = @_;
	    eval q( &private:  &static  &bool  &parse_  $name( &const \'char\'*  &str, \'int\'  &n,  &void*  &dest);  &static  &bool  &parse_  $name   &_radix(  &const \'char\'*  &str, \'int\'  &n,  &void*  &dest, \'int\'  &radix);  &public:  &static  &bool  &parse_  $name   &_hex( &const \'char\'*  &str, \'int\'  &n,  &void*  &dest);  &static  &bool  &parse_  $name   &_octal( &const \'char\'*  &str, \'int\'  &n,  &void*  &dest);  &static  &bool  &parse_  $name   &_cradix( &const \'char\'*  &str, \'int\'  &n,  &void*  &dest));
    }' unless defined(&PCRE_DECLARE_INTEGER_PARSER);
    undef(&PCRE_DECLARE_INTEGER_PARSER) if defined(&PCRE_DECLARE_INTEGER_PARSER);
    eval 'sub MAKE_INTEGER_PARSER {
        my($type, $name) = @_;
	    eval q( &inline  &Arg  &Hex($type*  &ptr) {  &return  &Arg( &ptr,  &Arg:: &parse_  $name   &_hex); }  &inline  &Arg  &Octal($type*  &ptr) {  &return  &Arg( &ptr,  &Arg:: &parse_  $name   &_octal); }  &inline  &Arg  &CRadix($type*  &ptr) {  &return  &Arg( &ptr,  &Arg:: &parse_  $name   &_cradix); });
    }' unless defined(&MAKE_INTEGER_PARSER);
    if(1) {
    }
    if(1) {
    }
    undef(&PCRE_IS_SET) if defined(&PCRE_IS_SET);
    undef(&PCRE_SET_OR_CLEAR) if defined(&PCRE_SET_OR_CLEAR);
    undef(&MAKE_INTEGER_PARSER) if defined(&MAKE_INTEGER_PARSER);
}
1;
